#ifndef Inc_HQConfIo_H
#define Inc_HQConfIo_H

#include <qobject.h>
#include <qstring.h>
#include <qstringlist.h>
#include <qfile.h>
#include <qdir.h>
#include <qtextstream.h>
#include <qtextcodec.h>

class HQConfIo {
public:
	HQConfIo(const QString& qstAppName = "");
	~HQConfIo();

	void setFileName(const QString& qstFilename);
	void setCodecName(const QString& qstCodec);

	int setLoadMode();
	bool setSaveMode();

	bool setGroup(const QString &qstGroup);
	bool setStrValue(const QString &qstTag,const QString &qstValue);
	bool setIntValue(const QString &qstTag,int iValue);
	bool flash();

	bool getStrValue(const QString& qstGroup,const QString& qstTag,QString& qstResultValue,QString qstDefaultValue = "",int iMaxLen = 0);
	bool getIntValue(const QString& qstGroup,const QString& qstTag,int& iResultValue,int iDefaultValue = 0,int iMinLimit = 0,int iMaxLimit = 0);

private:
	bool readConfFile();
	QString stripLeftSpace(QString qstString);
	bool searchValue(const QString& qstGroup,const QString& qstTag,QString& qstValue);

	QFile*			qflFileHandle;

	QStringList		qstVarBuf;

	int				iIO_Mode;		/* 0:設定されていない 1:Read 2:Write */

	int				iMaxVarCnt;

	QString			qstCodecName;
};

#endif // Inc_HQConfIo_H
