#include "HQPppEnv.h"

HQPppEnv::HQPppEnv(const QString qstName, const QString qstMsg, QObject* qoParent, const char* cpName) : QObject(qoParent, cpName)
{
	qstAppname = qstName;
	qstMessage = qstMsg;

	qcpNetChannel = new QCopChannel( "QPE/Network", this );
	connect( qcpNetChannel, SIGNAL(received(const QCString &, const QByteArray &)), this, SLOT(netMessageRecvSlot( const QCString &, const QByteArray &)) );
}

HQPppEnv::~HQPppEnv()
{
	delete qcpNetChannel;
}

void HQPppEnv::connectPPP()
{
	QCopEnvelope eEnv("QPE/Network", "connectRequest(QString,QString)");

	eEnv << qstAppname << qstMessage;
}

void HQPppEnv::disconnectPPP()
{
	QCopEnvelope eEnv("QPE/Network", "stop()");
}

void HQPppEnv::netMessageRecvSlot(const QCString& qstMsg, const QByteArray&)
{
	if(qstMsg == "up()") emit netConnectingSignal();
}

int HQPppEnv::IsConnecting()
{
	struct	ifconf	ifc;
	struct	ifreq	*ifr;

	int				iResult = 0;

	int				iSocket;
	int				iSize;
	int				iCnt = 2;

	iSocket = socket(AF_INET,SOCK_DGRAM,0);

	while(1)
	{
		iSize = ifc.ifc_len = sizeof(struct ifreq) * iCnt;

		ifc.ifc_buf = (char *)malloc(iSize);

		if(ifc.ifc_buf == NULL)
		{
			// mem error
			return -1;
		}

		if(ioctl(iSocket, SIOCGIFCONF, &ifc) < 0)
		{
			// func error
			free(ifc.ifc_buf);
			return -1;
		}

		if(ifc.ifc_len == iSize)
		{
			// overflow?
			free(ifc.ifc_buf);
			iCnt *= 2;
		}
		else
		{
			// success
			break;
		}
	}

	ifr = ifc.ifc_req;
	for(iCnt = 0;iCnt < (ifc.ifc_len / (int)sizeof(struct ifreq));iCnt++)
	{
		if(strcmp(ifr->ifr_name,"ppp0") == 0)
		{
			iResult = 1;
			break;
		}
		else if(strcmp(ifr->ifr_name,"eth0") == 0)
		{
			iResult = 2;
			break;
		}

		ifr++;
	}

	free(ifc.ifc_buf);

	return iResult;
}
