#ifndef Inc_HQSntp_H
#define Inc_HQSntp_H

#include <qmessagebox.h>
#include <qstring.h>
#include <qdns.h>
#include <qhostaddress.h>
#include <qsocketdevice.h>
#include <qsocketnotifier.h>
#include <qdatetime.h>
#include <qtimer.h>

#include <netinet/in.h>
#include <sys/time.h>

//#include <qsocket.h>

class HQSntp : public QObject {
	Q_OBJECT
public:
	HQSntp(const QString& qstHostname, int iConectport, int iTimeout,bool blAutoQuit, QObject* qoParent, const char* cpName = 0);
	~HQSntp();

	void sendNtpPacket();

signals:
	void requestDisposeHQSntpSignal();
	void requestDispMessageHQSntpSignal(QString &qstDispStr);
	void setSystemClockSignal();
	void requestAutoQuitRequestSignal();

//protected

private slots:
	void sendPacketExecSlot();
	void packetReadNotifySlot();
	void packetWriteNotifySlot();
	void timeoutNotfySlot();

private:
	QWidget*			qwdParent;

	QSocketDevice*		qscSocketDev;
	QString				qstConnectHostStr;
	int					iConnectHostPort;

	QDns*				qdnDns;
	QHostAddress		qhaConnectHostAddr;

	QHostAddress		qhaInAddrAny;
	int					iLocalPort;

	QSocketNotifier*	qsnReadNotify;
	QSocketNotifier*	qsnWriteNotify;
	QTimer*				qtrTimeoutNotify;

	int					iTimeOutMsec;
	bool				blAutoQuitNotify;

	char				hspSendPacket[48];
	char				hspRecvPacket[48];

	void requestDisposeObj(void);
	void requestDispMessage(QString &qstDispStr);
	void adjustSystemTime();
	int timevalSub(struct timeval* tvResult,struct timeval* tvA,struct timeval* tvB);
	void timevalAdd(struct timeval* tvA,struct timeval* tvB);
	void timevalDiv(struct timeval* tvResult,struct timeval* tvA,int iDiv);
	int getIntVal4Buf(char *cpBuf,int iOffset);
	void getTimeval4buf(struct timeval* tvResult,char *cpBuf,int iOffset);
	void setBuf4Timeval(char *cpBuf,struct timeval* tvVal,int iOffset);
};

#endif	// Inc_HQSntp_H
