#ifndef Inc_MainFm_H
#define Inc_MainFm_H

#include "MainUI.h"
#include "SettingBase.h"
#include "AplVarList.h"
#include "HQSntp.h"
#include "HQPppEnv.h"

#define		WDG_VGA_FixS_WIDTH		360
#define		WDG_VGA_FixS_HEIGHT		350

#define		WDG_VGA_FixL_WIDTH		460
#define		WDG_VGA_FixL_HEIGHT		430

#define		WDG_QVGA_FixWIDTH		230
#define		WDG_QVGA_FixHEIGHT		300

class MainFm:public MainUI
{
Q_OBJECT

public:
	MainFm( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
	~MainFm();

#ifdef DTK_APPLET
	QSize sizeHint() const;
#endif

	bool isVgaDisp() const;

private:
	QWidget*		tabID2;
	QFrame*			button2Frm;
	QPushButton*	okSetBtn;
	QPushButton*	canselSetBtn;
	SettingBase*	baseSWd;

	QTimer*			qtrClockInt;

	QTimer*			qtrDisconnectCnt;

	AplVarList*		aplVarList;

	bool			blIsSetupTabReady;

	QTimer*			qtrAutoQuitTimer;

	HQSntp*			hqSntpfx;

	HQPppEnv*		hqPppEnv;

	bool			blUpNotfy2Adjust;
	bool			blPppUp2AdjustTrigger;

	bool			S_SL300Flag;

	int				S_FontSize[2];

	bool			S_LargeFontDisp;			// 大きいフォントで表示			true = 9P Font＋大きい画面で表示
	bool			S_SyncPppUp;				// ネットワーク接続と連動する	true = する
	bool			S_PppDisconnected;			// PPPが切断されているかを判別	true = PPP切断状態
	bool			S_EnableTimeAdjustExec;		// SNTP処理実行許可				true = 実行可能

	void setDispFontSize();

	void setHostListCBoxItem();

	void setSetupTabDatas(bool blAutoQuit);
	void getSetupTabDatas(QString &qstHostList,int &iTimeout,bool &blNotfy2Adj, bool &blStop,bool &blStop2,bool &blStart,bool &blAutoQuit);
	QString commentOutStr(QString qstStr);

private slots:
	void disposeSocketSlot();
	void recvSetSystemClockSlot();
	void execTimeAdjustSlot();
	void displayMessageStrSlot(QString &qstDispStr);

	void recvNetConnectSlot();
	void recvNetDisconnectSlot();

	void recvAutoQuitRequestSlot();

	void dispTimeDigitSlot();

	void autoQuitSlot();

	void pressOnlineBtnSlot();
	void pressTabSlot(QWidget *qwdTab);
	void pressQuitBtnSlot();
	void pressDefaultBtnSlot();
	void pressOkSetBtnSlot();
	void pressCanselSetBtnSlot();

	void pressSyncPppChkSlot();
	void pressPppStopChkSlot();
	void pressPppStopChk2Slot();

protected:
	bool event( QEvent* ev );
	void showEvent(QShowEvent* evShow);
	void hideEvent(QHideEvent* evHide);
	void keyPressEvent(QKeyEvent *);

	QGridLayout* tabID2Layout;
	QGridLayout* button2FrmLayout;
};

#endif	// Inc_MainFm_H
