#include "SettingBase.h"

#include <qpe/qpeapplication.h>
#include <qcheckbox.h>

HQVScrollFm::HQVScrollFm( QWidget* parent,  const char* name, WFlags fl )
    : SettingBaseUI( parent, name, fl )
{
}

HQVScrollFm::~HQVScrollFm()
{
}

SettingBase::SettingBase( QWidget* parent,  const char* name, WFlags fl )
    : QScrollView( parent, name, fl )
{
	setHScrollBarMode(AlwaysOff);
	setVScrollBarMode(AlwaysOn);

	qwdParent = parent;

	vItem = new HQVScrollFm( parent, name, fl );

	addChild(vItem);

	resizeSlot();
}

SettingBase::~SettingBase()
{
	delete vItem;
}

// public slot
void SettingBase::resizeSlot()
{
	if( qwdParent == 0 )
	{
		resize( QPEApplication::desktop()->size() );
	}
	else
	{
		resize( qwdParent->size() );
	}
}

// event
void SettingBase::resizeEvent( QResizeEvent* evResize )
{
	QSize	qsViewport	= viewportSize(0,0);

	int		iHeight;

	if(vItem->height() < qsViewport.height())
	{
		iHeight = qsViewport.height();
	}
	else
	{
		iHeight = vItem->height();
	}

	vItem->resize(qsViewport.width(), iHeight);

	QScrollView::resizeEvent(evResize);
}
